diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 100b70b02..68835d3a5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -16,7 +16,6 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -69,7 +68,7 @@ public class BlockLogicButton
 
     @Override
     public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @NotNull Side checkSide = side.getOpposite();
+        final @NotNull Side checkSide = side.opposite();
         return this.isSupported(world, tilePos, checkSide);
     }
 
@@ -131,7 +130,7 @@ public class BlockLogicButton
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, @NotNull Side side, final double xHit, final double yHit) {
         int orientation = -1;
         if (side.isHorizontal()) {
-            side = side.getOpposite();
+            side = side.opposite();
         }
         switch (side) {
             case BOTTOM:
@@ -254,6 +253,18 @@ public class BlockLogicButton
         return this.press(world, tilePos, player);
     }
 
+    private static @NotNull Direction getDirection(int directionWeird) {
+        return switch (directionWeird) {
+            default -> Direction.NONE;
+            case SIDE_WEST -> Direction.WEST;
+            case SIDE_EAST -> Direction.EAST;
+            case SIDE_NORTH -> Direction.NORTH;
+            case SIDE_SOUTH -> Direction.SOUTH;
+            case SIDE_TOP -> Direction.UP;
+            case SIDE_BOTTOM -> Direction.DOWN;
+        };
+    }
+
     private boolean press(final @NotNull World world, final @NotNull TilePosc tilePos, final @Nullable Player player) {
         final int meta = world.getBlockData(tilePos);
         final int direction = meta & MASK_DIRECTION;
@@ -261,31 +272,11 @@ public class BlockLogicButton
         if (isPowered) {
             return false;
         }
-        world.setBlockDataNotify(tilePos, (meta & ~MASK_DIRECTION) | direction | MASK_POWERED);
-        world.markBlockDirty(tilePos);
+        world.setBlockData(tilePos, (meta & ~MASK_DIRECTION) | direction | MASK_POWERED);
+        world.markBlockNeedsUpdate(tilePos);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
 
-        switch (direction) {
-            case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
-                break;
-            case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
-                break;
-            case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
-                break;
-            case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
-                break;
-            case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
-                break;
-            case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
-                break;
-        }
+        world.notifyBlocksInCapsuleOfNeighborChange(getDirection(direction), tilePos, this.block);
         world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
         return true;
     }
@@ -298,28 +289,8 @@ public class BlockLogicButton
     @Override
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         if ((data & MASK_POWERED) != 0) {
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
             final int direction = data & MASK_DIRECTION;
-            switch (direction) {
-                case SIDE_WEST:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
-                    break;
-                case SIDE_EAST:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
-                    break;
-                case SIDE_NORTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
-                    break;
-                case SIDE_SOUTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
-                    break;
-                case SIDE_TOP:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
-                    break;
-                case SIDE_BOTTOM:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
-                    break;
-            }
+            world.notifyBlocksInCapsuleOfNeighborChange(getDirection(direction), tilePos, this.block);
         }
         super.onRemoved(world, tilePos, data);
     }
@@ -361,32 +332,12 @@ public class BlockLogicButton
         if ((meta & MASK_POWERED) == 0) {
             return;
         }
-        world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
         final int direction = meta & MASK_DIRECTION;
-        switch (direction) {
-            case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
-                break;
-            case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
-                break;
-            case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
-                break;
-            case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
-                break;
-            case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
-                break;
-            case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
-                break;
-        }
+        world.setBlockData(tilePos, meta & ~MASK_POWERED);
+        world.markBlockNeedsUpdate(tilePos);
+        world.notifyBlocksInCapsuleOfNeighborChange(getDirection(direction), tilePos, this.block);
 
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
-        world.markBlockDirty(tilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 983adec37..62d75eadb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -52,8 +52,11 @@ public class BlockLogicCactus
             if (cactusHeight < 3) {
                 final int data = world.getBlockData(tilePos);
                 if (data == 15) {
-                    world.setBlockTypeNotify(tilePos.add(Direction.UP, queryPos), this.block);
-                    world.setBlockDataNotify(tilePos, 0);
+                    world.setBlockData(tilePos, 0);
+                    world.setBlockType(tilePos.add(Direction.UP, queryPos), this.block);
+                    world.markBlockNeedsUpdate(tilePos);
+                    world.markBlockNeedsUpdate(queryPos);
+                    world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, tilePos, this.block);
                 } else {
                     world.setBlockDataNotify(tilePos, data + 1);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index fc75af867..690af327d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -27,12 +27,12 @@ public class BlockLogicChest
 
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        @NotNull Direction direction = mob.getHorizontalPlacementDirection(side).getOpposite();
+        @NotNull Direction direction = mob.getHorizontalPlacementDirection(side).opposite();
         @NotNull Type type = Type.SINGLE;
 
         TilePos queryPos = new TilePos();
-        if (mob.isSneaking() && side.isHorizontal() && (mob.rotationLockHorizontal == null || mob.rotationLockHorizontal == Direction.NONE)) {
-            final @NotNull TilePos placedOn = tilePos.sub(side.getDirection(), new TilePos());
+        if (mob.isSneaking() && side.isHorizontal() && mob.rotationLockHorizontal == null) {
+            final @NotNull TilePos placedOn = tilePos.sub(side.direction(), new TilePos());
 
             if (isSingleChest(world, placedOn)) {
                 final @NotNull Direction direction2 = getDirectionFromMeta(world.getBlockData(placedOn));
@@ -137,7 +137,7 @@ public class BlockLogicChest
 
     @Override
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
-        final Direction direction = side.getDirection();
+        final Direction direction = side.direction();
         Type type = Type.SINGLE;
         TilePos queryPos = new TilePos();
         if (direction == Direction.NORTH) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index 448a650a7..adad84a0d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -136,21 +136,21 @@ public class BlockLogicConduit extends BlockLogic {
      */
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc cTilePos, final @NotNull Side sidePlacedOnto, final @NotNull Mob mob, final double xHit, final double yHit) {
-        Side sideFacingPlayer = Direction.getDirection(mob).getOpposite().getSide();
-        Side sideClickedAgainst = sidePlacedOnto.getOpposite();
+        Side sideFacingPlayer = Direction.getLockable(mob).opposite().side();
+        Side sideClickedAgainst = sidePlacedOnto.opposite();
 
         int stateToPlaceAs = 0;
 
         if (mob instanceof Player player) {
-            if (player.rotationLock != null && player.rotationLock != Direction.NONE) {
-                Side lockSide = player.rotationLock.getSide();
-                stateToPlaceAs = getStateFromTwoSides(lockSide, lockSide.getOpposite());
+            if (player.rotationLock != null) {
+                Side lockSide = player.rotationLock.side();
+                stateToPlaceAs = getStateFromTwoSides(lockSide, lockSide.opposite());
             }
         }
 
         if (stateToPlaceAs == 0 && mob.isSneaking()) {
             boolean openedClosedFace = false;
-            TilePos clickedPos = new TilePos(cTilePos.x() + sideClickedAgainst.getOffsetX(), cTilePos.y() + sideClickedAgainst.getOffsetY(), cTilePos.z() + sideClickedAgainst.getOffsetZ());
+            TilePos clickedPos = new TilePos(cTilePos.x() + sideClickedAgainst.offsetX(), cTilePos.y() + sideClickedAgainst.offsetY(), cTilePos.z() + sideClickedAgainst.offsetZ());
 
             if (world.getBlockType(clickedPos) == this.block) {
                 int clickedData = world.getBlockData(clickedPos);
@@ -170,12 +170,12 @@ public class BlockLogicConduit extends BlockLogic {
             }
 
             if (openedClosedFace) {
-                stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.getOpposite());
+                stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
             } else {
                 if (sideClickedAgainst != sideFacingPlayer && sideFacingPlayer != Side.NONE) {
                     stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideFacingPlayer);
                 } else {
-                    stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.getOpposite());
+                    stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
                 }
             }
         }
@@ -183,12 +183,12 @@ public class BlockLogicConduit extends BlockLogic {
             List<Side> validSides = new ArrayList<>();
 
             for (Side side : Side.values()) {
-                TilePos nTilePos = new TilePos(cTilePos.x() + side.getOffsetX(), cTilePos.y() + side.getOffsetY(), cTilePos.z() + side.getOffsetZ());
+                TilePos nTilePos = new TilePos(cTilePos.x() + side.offsetX(), cTilePos.y() + side.offsetY(), cTilePos.z() + side.offsetZ());
 
                 if (world.getBlockType(nTilePos) == this.block) {
                     int nData = world.getBlockData(nTilePos);
 
-                    if (isSideOpen(nData, side.getOpposite())) {
+                    if (isSideOpen(nData, side.opposite())) {
                         validSides.add(side);
                     }
                 }
@@ -202,7 +202,7 @@ public class BlockLogicConduit extends BlockLogic {
                 if (sideFacingPlayer != autoConnectedSide && sideFacingPlayer != Side.NONE) {
                     stateToPlaceAs = getStateFromTwoSides(autoConnectedSide, sideFacingPlayer);
                 } else {
-                    stateToPlaceAs = getStateFromTwoSides(autoConnectedSide, autoConnectedSide.getOpposite());
+                    stateToPlaceAs = getStateFromTwoSides(autoConnectedSide, autoConnectedSide.opposite());
                 }
             } else if (numOfValidSides == 2) {
                 stateToPlaceAs = getStateFromTwoSides(validSides.get(0), validSides.get(1));
@@ -216,7 +216,7 @@ public class BlockLogicConduit extends BlockLogic {
                     if (sideFacingPlayer != sideClickedAgainst && sideFacingPlayer != Side.NONE) {
                         stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideFacingPlayer);
                     } else {
-                        stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.getOpposite());
+                        stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
                     }
                 }
             }
@@ -311,7 +311,7 @@ public class BlockLogicConduit extends BlockLogic {
     public static byte packEventConduitData(Side side, int strength) {
         if (side == null) side = Side.NONE;
         int s = Math.max(0, Math.min(PROPAGATION_LENGTH, strength));
-        int sideId = side.getId() & 0x07;
+        int sideId = side.id & 0x07;
         return (byte) ((sideId << POWER_SHIFT) | (s & POWER_MASK));
     }
 
@@ -331,17 +331,17 @@ public class BlockLogicConduit extends BlockLogic {
 
         if (currentPower == 0) return false;
 
-        TilePos receiverPos = new TilePos(tilePos).add(side.getOpposite());
+        TilePos receiverPos = new TilePos(tilePos).add(side.opposite());
         if (world.getBlockType(receiverPos) == Blocks.WIRE_REDSTONE) {
             return false;
         }
 
-        return isSideOpen(data, side.getOpposite());
+        return isSideOpen(data, side.opposite());
     }
 
     private int getNextState(int currentState, @NotNull Side sideQueried) {
         if (currentState == 0) {
-            return getStateFromTwoSides(sideQueried, sideQueried.getOpposite());
+            return getStateFromTwoSides(sideQueried, sideQueried.opposite());
         }
 
         Side[] currentSides = STATE_TABLE[currentState];
@@ -383,7 +383,7 @@ public class BlockLogicConduit extends BlockLogic {
      */
     public static int getAndConvertNeighborSignal(@NotNull WorldSource world, @NotNull TilePosc cTilePos, @NotNull Side side) {
 
-        TilePos nTilePos = new TilePos(cTilePos.x() + side.getOffsetX(), cTilePos.y() + side.getOffsetY(), cTilePos.z() + side.getOffsetZ());
+        TilePos nTilePos = new TilePos(cTilePos.x() + side.offsetX(), cTilePos.y() + side.offsetY(), cTilePos.z() + side.offsetZ());
         Block<?> nBlockType = world.getBlockType(nTilePos);
 
         int cStrength = (world.getBlockData(cTilePos) >> POWER_SHIFT) & POWER_MASK;
@@ -396,7 +396,7 @@ public class BlockLogicConduit extends BlockLogic {
 
         if (nBlockType == Blocks.CONDUIT) {
             int nData = world.getBlockData(nTilePos);
-            if (isSideOpen(nData, side.getOpposite())) {
+            if (isSideOpen(nData, side.opposite())) {
                 int nStrength = (nData >> POWER_SHIFT) & POWER_MASK;
 
                 if (nStrength <= cStrength) return 0;
@@ -411,7 +411,7 @@ public class BlockLogicConduit extends BlockLogic {
 
             if (world1.isBlockNormalCube(nTilePos) && !isPowerCube) {
                 for (Side s : Side.sides) {
-                    TilePos queryPos = new TilePos(nTilePos.x() + s.getOffsetX(), nTilePos.y() + s.getOffsetY(), nTilePos.z() + s.getOffsetZ());
+                    TilePos queryPos = new TilePos(nTilePos.x() + s.offsetX(), nTilePos.y() + s.offsetY(), nTilePos.z() + s.offsetZ());
                     Block<?> queryBlock = world1.getBlockType(queryPos);
 
                     if (queryBlock != Blocks.WIRE_REDSTONE && queryBlock != Blocks.CONDUIT) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index 223ca8dbc..47ef77a98 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -47,9 +47,9 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
 
     private void dispenseItem(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random random) {
         final @NotNull Direction direction = BlockLogicVeryRotatable.metaToDirection(world.getBlockData(tilePos));
-        final int xOffset = direction.getOffsetX();
-        final int yOffset = direction.getOffsetY();
-        final int zOffset = direction.getOffsetZ();
+        final int xOffset = direction.offsetX();
+        final int yOffset = direction.offsetY();
+        final int zOffset = direction.offsetZ();
 
         final @NotNull TileEntityDispenser tileEntity = (TileEntityDispenser) Objects.requireNonNull(world.getTileEntity(tilePos));
         int stackIndex = tileEntity.getRandomStackIndexFromInventory();
@@ -97,7 +97,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
                 }
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_ITEM, 0);
             }
-            world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.getId());
+            world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.id);
         }
         if (stackIndex >= 0 && itemStack != null && itemStack.stackSize <= 0) {
             tileEntity.setItem(stackIndex, null);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index d7163bb7e..86a67a49d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -56,12 +56,13 @@ public class BlockLogicDoor
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final int meta = world.getBlockData(tilePos);
         if (world.hasNeighborSignal(tilePos)) {
-            world.setBlockDataNotify(tilePos, meta | MASK_OPENED);
-            if (this.isTop) {
-                world.setBlockDataNotify(tilePos.down(new TilePos()), meta | MASK_OPENED);
-            } else {
-                world.setBlockDataNotify(tilePos.up(new TilePos()), meta | MASK_OPENED);
-            }
+            world.setBlockData(tilePos, meta | MASK_OPENED);
+            final var dir = this.isTop ? Direction.DOWN : Direction.UP;
+            world.setBlockData(tilePos.add(dir, new TilePos()), meta | MASK_OPENED);
+
+            world.markBlockNeedsUpdate(tilePos);
+            world.markBlockNeedsUpdate(tilePos.add(dir, new TilePos()));
+            world.notifyBlocksInCapsuleOfNeighborChange(dir, tilePos, this.block);
             world.playBlockEvent(tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
         }
     }
@@ -163,7 +164,7 @@ public class BlockLogicDoor
 
     @Override
     public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
-        this.onInteracted(world, tilePos, null, direction.getSide(), 0.5, 0.5);
+        this.onInteracted(world, tilePos, null, direction.side(), 0.5, 0.5);
     }
 
     public void onPoweredBlockChange(final @NotNull World world, final @NotNull TilePosc tilePos, boolean isPowered) {
@@ -300,22 +301,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 1: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 2: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 3: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
 
@@ -324,22 +325,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 1: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 2: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 3: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                 }
@@ -349,22 +350,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 1: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 2: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
                     case 3: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
                     }
 
@@ -373,22 +374,22 @@ public class BlockLogicDoor
                 switch (this.getRotation(data)) {
                     case 0: {
                         side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 1: {
                         side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 2: {
                         side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                     case 3: {
                         side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.getDirection(), queryPos), side.getOpposite());
+                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
                         return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
                     }
                 }
